<?php
/*
Simple:Press
Admin Toolbox Update Options Support Functions
$LastChangedDate: 2012-03-22 20:53:23 -0700 (Thu, 22 Mar 2012) $
$Rev: 8195 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function spa_save_toolbox_data() {
	check_admin_referer('forum-adminform_toolbox', 'forum-adminform_toolbox');

	$mess = spa_text('Options Updated');

	# build number update
	if (empty($_POST['sfbuild']) || $_POST['sfbuild'] == 0) {
		sp_update_option('sfbuild', SPBUILD);
	} else {
		if ($_POST['sfbuild'] != SPBUILD && isset($_POST['sfforceupgrade'])) sp_update_option('sfbuild', sp_esc_int($_POST['sfbuild']));
	}

	sp_update_option('sfforceupgrade', isset($_POST['sfforceupgrade']));

    do_action('sph_toolbox_save');

	return $mess;
}

function spa_save_toolbox_clearlog() {
	check_admin_referer('forum-adminform_clearlog', 'forum-adminform_clearlog');
	$mess = spa_text('Log Emptied');

	# Clear out the error log table
	spdb_query("TRUNCATE TABLE ".SFERRORLOG);

    do_action('sph_toolbox_log_clear');

	return $mess;
}

function spa_save_uninstall_data() {
	check_admin_referer('forum-adminform_uninstall', 'forum-adminform_uninstall');
	$mess = spa_text('Options Updated');

	# Are we setting the uninstall flag?
	spa_update_check_option('sfuninstall');
	if (isset($_POST['sfuninstall'])) $mess = spa_text('Simple:Press will be removed when de-activated');

    do_action('sph_toolbox_uninstall_save');

	return $mess;
}

function spa_save_housekeeping_data() {
	check_admin_referer('forum-adminform_housekeeping', 'forum-adminform_housekeeping');

	$mess = '';
	if ($_POST['rebuild-fidx']) {
        $forumid = $_POST['forum_id'];
        if (is_numeric($forumid)) {
    		$topics = spdb_table(SFTOPICS, "forum_id=$forumid");
    		if ($topics) {
    			include_once (SF_PLUGIN_DIR.'/forum/database/sp-db-management.php');
    			foreach ($topics as $topic) {
                    sp_build_post_index($topic->topic_id);
    			}
                # after reubuilding post indexes, rebuild the forum indexes
                sp_build_forum_index($forumid);

                do_action('sph_toolbox_housekeeping_forum_index');
                $mess = spa_text('Forum indexes rebuilt');
    		} else {
        		$mess = spa_text('Forum index rebuild failed - no topics in selected forum');
            }
        } else {
    		$mess = spa_text('Forum index rebuild failed - no forum selected');
        }
	}

	if ($_POST['transient-cleanup']) {
		include_once (SF_PLUGIN_DIR.'/forum/database/sp-db-management.php');
		sp_transient_cleanup();
        do_action('sph_toolbox_housekeeping_transient');
		$mess = spa_text('WP transients cleaned');
	}

	if ($_POST['clean-newposts']) {
		$days = isset($_POST['sfdays']) ? max(sp_esc_int($_POST['sfdays']), 0) : 30;
		$users = spdb_select('col', "SELECT user_id FROM ".SFMEMBERS." WHERE lastvisit < DATE_SUB(CURDATE(), INTERVAL ".$days." DAY)");
		if ($users) {
			foreach ($users as $user) {
				spdb_query("UPDATE ".SFMEMBERS." SET newposts='a:1:{i:0;i:0;}' WHERE user_id=".$user);
			}
		}
        do_action('sph_toolbox_housekeeping_newpost');
		$mess = spa_text('New posts lists cleaned');
	}

	if ($_POST['reset-tabs']) {
		# clear out current tabs
		$tabs = sp_get_sfmeta('profile', 'tabs');
		sp_delete_sfmeta($tabs[0]['meta_id']);

		# start adding new ones
    	spa_new_profile_setup();

        do_action('sph_toolbox_housekeeping_profile_tabs');
		$mess = spa_text('Profile tabs reset');
	}

	if ($_POST['reset-auths']) {
        sp_reset_auths();
        do_action('sph_toolbox_housekeeping_auths');
		$mess = spa_text('Auths caches cleaned');
	}

    do_action('sph_toolbox_housekeeping_save');

	return $mess;
}

function spa_save_inspector_data() {
	global $spThisUser;
	check_admin_referer('forum-adminform_inspector', 'forum-adminform_inspector');
	$mess = 'Options Updated';
	$i = $spThisUser->ID;
	$ins = array();
	$ins = sp_get_option('spInspect');

	$ins[$i]['con_sfvars']		= isset($_POST['con_sfvars']);
	$ins[$i]['con_sfglobals']	= isset($_POST['con_sfglobals']);
	$ins[$i]['con_spThisUser']	= isset($_POST['con_spThisUser']);

	$ins[$i]['gv_spGroupView']	= isset($_POST['gv_spGroupView']);
	$ins[$i]['gv_spThisGroup']	= isset($_POST['gv_spThisGroup']);
	$ins[$i]['gv_spThisForum']	= isset($_POST['gv_spThisForum']);
	$ins[$i]['gv_spThisForumSubs']	= isset($_POST['gv_spThisForumSubs']);

	$ins[$i]['fv_spForumView']	= isset($_POST['fv_spForumView']);
	$ins[$i]['fv_spThisForum']	= isset($_POST['fv_spThisForum']);
	$ins[$i]['fv_spThisForumSubs']	= isset($_POST['fv_spThisForumSubs']);
	$ins[$i]['fv_spThisSubForum']	= isset($_POST['fv_spThisSubForum']);
	$ins[$i]['fv_spThisTopic']	= isset($_POST['fv_spThisTopic']);

	$ins[$i]['tv_spTopicView']	= isset($_POST['tv_spTopicView']);
	$ins[$i]['tv_spThisTopic']	= isset($_POST['tv_spThisTopic']);
	$ins[$i]['tv_spThisPost']	= isset($_POST['tv_spThisPost']);
	$ins[$i]['tv_spThisPostUser']	= isset($_POST['tv_spThisPostUser']);

	$ins[$i]['mv_spMembersList']	= isset($_POST['mv_spMembersList']);
	$ins[$i]['mv_spThisMemberGroup']	= isset($_POST['mv_spThisMemberGroup']);
	$ins[$i]['mv_spThisMember']	= isset($_POST['mv_spThisMember']);

	$ins[$i]['tlv_spTopicListView']	= isset($_POST['tlv_spTopicListView']);
	$ins[$i]['tlv_spThisListTopic']	= isset($_POST['tlv_spThisListTopic']);

	$ins[$i]['plv_spPostListView']	= isset($_POST['plv_spPostListView']);
	$ins[$i]['plv_spThisListPost']	= isset($_POST['plv_spThisListPost']);

	$ins[$i]['pro_spProfileUser']	= isset($_POST['pro_spProfileUser']);

	sp_update_option('spInspect', $ins);

    do_action('sph_toolbox_inspector_save');

	return $mess;
}

?>