<?php
/*
Simple:Press
Edit Tools - Move Topic/Move Post
$LastChangedDate: 2012-03-30 10:19:35 -0700 (Fri, 30 Mar 2012) $
$Rev: 8248 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

sp_forum_api_support();

# get out of here if no action specified
if (empty($_GET['action'])) die();
$action = $_GET['action'];

if ($action == 'move-topic') sp_move_topic_popup();
if ($action == 'move-post') sp_move_post_popup();
if ($action == 'edit-title') sp_edit_title_popup();
if ($action == 'reassign') sp_reassign_post_popup();
if ($action == 'properties') sp_show_properties();

die();

function sp_move_topic_popup() {
	$topicid = sp_esc_int($_GET['topicid']);
	$forumid = sp_esc_int($_GET['forumid']);
	if (!sp_get_auth('move_topics', $forumid)) {
		if (!is_user_logged_in()) {
			sp_etext('Access denied - are you logged in?');
		} else {
			sp_etext('Access denied - you do not have permission');
		}
		die();
	}

	$thistopic = spdb_table(SFTOPICS, "topic_id=$topicid", 'row');
	$thisforum = spdb_table(SFFORUMS, "forum_id=$forumid", 'row');
    if (empty($thistopic) || empty($thisforum)) die();

	include_once(SPAPI.'sp-api-common-display.php');
?>
	<div id="spMainContainer" class="spForumToolsPopup">
		<div class="spForumToolsHeader">
			<div class="spForumToolsHeaderTitle"><?php sp_etext('Select new forum for this topic').':'; ?></div>
			<div class="spForumToolsHeaderTitle"><?php echo sp_filter_title_display($thistopic->topic_name); ?></div>
		</div>
		<form action="<?php echo sp_build_url($thisforum->forum_slug, '', 1, 0); ?>" method="post" name="movetopicform">
			<input type="hidden" name="currenttopicid" value="<?php echo $topicid; ?>" />
			<input type="hidden" name="currentforumid" value="<?php echo $forumid; ?>" />
			<div class="spCenter">
				<?php echo sp_render_group_forum_select(false, false, true, true, sp_text('Select forum'), 'forumid', 'spSelect');	?><br /><br />
				<input type="submit" class="spSubmit" name="maketopicmove" value="<?php sp_etext('Move Topic to Selected Forum') ?>" />
				<input type="button" class="spSubmit" name="cancel" value="<?php sp_etext('Cancel') ?>" onclick="jQuery('#dialog').dialog('close');" />
			</div>
		</form>
	</div>
<?php
}

function sp_move_post_popup() {
	$thispost = sp_esc_int($_GET['pid']);
	$topicid = sp_esc_int($_GET['id']);
	$thispostindex = sp_esc_int($_GET['pix']);
	$thistopic = spdb_table(SFTOPICS, "topic_id=$topicid", 'row');
    if (empty($thispost) || empty($thistopic)) die();

	$thisforum = spdb_table(SFFORUMS, "forum_id=$thistopic->forum_id", 'row');
	if (!sp_get_auth('move_posts', $thistopic->forum_id)) {
		if (!is_user_logged_in()) {
			sp_etext('Access denied - are you logged in?');
		} else {
			sp_etext('Access denied - you do not have permission');
		}
		die();
	}
?>
	<div id="spMainContainer" class="spForumToolsPopup">
		<div class="spForumToolsHeader">
			<div class="spForumToolsHeaderTitle"><?php echo sp_text('Move post').' ('.sp_text('ID').":$thispost) ".sp_text('to new topic and forum'); ?></div>
		</div>
		<form action="<?php echo sp_build_url($thisforum->forum_slug, $thistopic->topic_slug, 1, 0); ?>" method="post" name="movepostform">
			<input type="hidden" name="postid" value="<?php echo $thispost; ?>" />
			<input type="hidden" name="oldtopicid" value="<?php echo $thistopic->topic_id; ?>" />
			<input type="hidden" name="oldforumid" value="<?php echo $thisforum->forum_id; ?>" />
			<div class="spCenter">
				<?php echo sp_render_group_forum_select(false, false, true, true, sp_text('Select forum'), 'forumid', 'spSelect');	?><br /><br />
				<p class="spCenter"><?php sp_etext('New topic name'); ?></p>
				<input type="text" class="spControl" size="80" name="newtopicname" value="" /><br /><br />
				<?php do_action('sph_move_post_form', $thispost, $topicid); ?>
				<input type="submit" class="spSubmit" name="makepostmove" value="<?php sp_etext('Move Post') ?>" />
				<input type="button" class="spSubmit" name="cancel" value="<?php sp_etext('Cancel') ?>" onclick="jQuery('#dialog').dialog('close');" />
			</div>
		</form>
	</div>
<?php
}

function sp_edit_title_popup() {
	global $spThisUser, $sfvars;

	$topicid = sp_esc_int($_GET['topicid']);
	$forumid = sp_esc_int($_GET['forumid']);
	$userid  = sp_esc_int($_GET['userid']);
	$thistopic = spdb_table(SFTOPICS, "topic_id=$topicid", 'row');

	if (!(sp_get_auth('edit_own_topic_titles', $forumid) && $userid == $spThisUser->ID) && !sp_get_auth('edit_any_topic_titles', $forumid)) {
		if (!is_user_logged_in()) {
			sp_etext('Access denied - are you logged in?');
		} else {
			sp_etext('Access denied - you do not have permission');
		}
		die();
	}
	$thisforum = spdb_table(SFFORUMS, "forum_id=$thistopic->forum_id", 'row');

	echo '<div id="spMainContainer" class="spForumToolsPopup">';
    $page = (isset($sfvars['page'])) ? $sfvars['page'] : 1;
	echo '<form action="'.sp_build_url($thisforum->forum_slug, '', $page, 0).'" method="post" name="edittopicform">';
	echo '<input type="hidden" name="tid" value="'.$thistopic->topic_id.'" />';
    echo '<div class="spCenter">';
	echo '<div class="spHeaderName">'.sp_text('Topic Title').':</div>';
	echo '<div><textarea class="spControl" name="topicname" rows="2">'.esc_textarea($thistopic->topic_name).'</textarea></div>';
	echo '<div class="spHeaderName">'.sp_text('Topic Slug').':</div>';
	echo '<div><textarea class="spControl" name="topicslug" rows="2">'.esc_textarea($thistopic->topic_slug).'</textarea></div>';
	echo '<div class="spCenter"><br />';
	echo '<input type="submit" class="spSubmit" name="edittopic" value="'.sp_text('Save').'" />';
	echo '<input type="button" class="spSubmit" name="cancel" value="'.sp_text('Cancel').'" onclick="jQuery(\'#dialog\').dialog(\'close\');" />';
	echo '</div>';
    echo '</div>';
	echo '</form>';
	echo '</div>';
}

function sp_reassign_post_popup() {
	$thispost = sp_esc_int($_GET['pid']);
	$thisuser = sp_esc_int($_GET['uid']);
    $thistopic = sp_esc_int($_GET['id']);
    if (empty($thispost) || empty($thistopic)) die();

	$thistopic = spdb_table(SFTOPICS, "topic_id=$thistopic", 'row');
	if (!sp_get_auth('reassign_posts', $thistopic->forum_id)) {
		if (!is_user_logged_in()) {
			sp_etext('Access denied - are you logged in?');
		} else {
			sp_etext('Access denied - you do not have permission');
		}
		die();
	}

	$thisforum = spdb_table(SFFORUMS, "forum_id=$thistopic->forum_id", 'row');
?>
	<div id="spMainContainer" class="spForumToolsPopup">
		<div class="spForumToolsHeader">
			<div class="spForumToolsHeaderTitle"><?php echo sp_text('Reassign post to new user').' ('.sp_text('current ID').': '.$thisuser.')'; ?></div>
		</div>
		<form action="<?php echo sp_build_url($thisforum->forum_slug, $thistopic->topic_slug, 1, 0); ?>" method="post" name="reassignpostform">
            <div class="spCenter">
    			<input type="hidden" name="postid" value="<?php echo $thispost; ?>" />
    			<input type="hidden" name="olduserid" value="<?php echo $thisuser; ?>" />
    			<?php sp_etext('New user ID'); ?>
    			<input type="text" class="spControl" size="80" name="newuserid" value="" /><br /><br />
    			<input type="submit" class="spSubmit" name="makepostreassign" value="<?php sp_etext('Reassign Post') ?>" />
    			<input type="button" class="spSubmit" name="cancel" value="<?php sp_etext('Cancel') ?>" onclick="jQuery('#dialog').dialog('close');" />
            </div>
		</form>
	</div>
<?php
}

function sp_show_properties() {
	global $spThisUser;

    $forumid = sp_esc_int($_GET['forum']);
    $topicid = sp_esc_int($_GET['topic']);
    if (empty($forumid) || empty($topicid)) die();

	$thistopic = spdb_table(SFTOPICS, "topic_id=$topicid", 'row');

	if (!$spThisUser->admin && !$spThisUser->moderator) {
		if (!is_user_logged_in()) {
			sp_etext('Access denied - are you logged in?');
		} else {
			sp_etext('Access denied - you do not have permission');
		}
		die();
	}
	$thisforum = spdb_table(SFFORUMS, "forum_id=$forumid", 'row');

	if (isset($_GET['post'])) {
		$groupid = sp_esc_int($thisforum->group_id);
		$thisgroup = spdb_table(SFGROUPS, "group_id=$groupid", 'row');
	} else {
        $groupid = sp_esc_int($_GET['group']);
        if (empty($groupid)) die();
		$thisgroup = spdb_table(SFGROUPS, "group_id=$groupid", 'row');
	}

	$posts = spdb_table(SFPOSTS, "topic_id=$thistopic->topic_id", '', 'post_id');
	if ($posts) {
		$first = $posts[0]->post_id;
		$last  = $posts[count($posts) - 1]->post_id;
	}

	# set timezone onto the started date
	$topicstart = sp_apply_timezone($thistopic->topic_date);

?>
	<div id="spMainContainer">
	<table class="spPopupTable">
		<tr><td class="spLabel" width="35%"><?php sp_etext('Group ID'); ?></td><td colspan="2" class="spLabel"><?php echo $thisgroup->group_id; ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Group Title'); ?></td><td colspan="2" class="spLabel"><?php echo sp_filter_title_display($thisgroup->group_name); ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Forum ID'); ?></td><td class="spLabel"><?php echo $thisforum->forum_id; ?></td><td class="sfdata"><?php echo sp_rebuild_forum_form($thisforum->forum_id, $thistopic->topic_id, $thisforum->forum_slug, $thistopic->topic_slug); ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Forum Title'); ?></td><td colspan="2" class="spLabel"><?php echo sp_filter_title_display($thisforum->forum_name); ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Forum Slug'); ?></td><td colspan="2" class="spLabel"><?php echo $thisforum->forum_slug; ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Topics in Forum'); ?></td><td colspan="2" class="spLabel"><?php echo $thisforum->topic_count; ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Topic ID'); ?></td><td class="spLabel"><?php echo $thistopic->topic_id; ?></td><td class="sfdata"><?php echo sp_rebuild_topic_form($thisforum->forum_id, $thistopic->topic_id, $thisforum->forum_slug, $thistopic->topic_slug); ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Topic Title'); ?></td><td colspan="2" class="spLabel"><?php echo sp_filter_title_display($thistopic->topic_name); ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Topic Slug'); ?></td><td colspan="2" class="spLabel"><?php echo $thistopic->topic_slug; ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Posts in Topic'); ?></td><td colspan="2" class="spLabel"><?php echo $thistopic->post_count; ?></td></tr>

		<tr><td class="spLabel"><?php sp_etext('Topic Started'); ?></td><td colspan="2" class="spLabel"><?php echo $topicstart; ?></td></tr>

		<tr><td class="spLabel"><?php sp_etext('First Post ID'); ?></td><td colspan="2" class="spLabel"><?php echo $first; ?></td></tr>
		<tr><td class="spLabel"><?php sp_etext('Last Post ID'); ?></td><td colspan="2" class="spLabel"><?php echo $last; ?></td></tr>
<?php
		if (isset($_GET['post'])) {
			$postid = sp_esc_int($_GET['post']);
			$post = spdb_table(SFPOSTS, "post_id=$postid");
?>
			<tr><td class="spLabel"><?php sp_etext('This Post ID'); ?></td><td colspan="2" class="spLabel"><?php echo $postid; ?></td></tr>
			<tr><td class="spLabel"><?php sp_etext('Poster ID'); ?></td><td colspan="2" class="spLabel"><?php echo $post[0]->user_id; ?></td></tr>
			<tr><td class="spLabel"><?php sp_etext('Poster IP'); ?></td><td colspan="2" class="spLabel"><?php echo $post[0]->poster_ip; ?></td></tr>
<?php
		}
?>
	</table>
	</div>
<?php
}

function sp_rebuild_forum_form($forumid, $topicid, $forumslug, $topicslug) {
	$out = '<form action="'.sp_build_url($forumslug, $topicslug, 1, 0).'" method="post" name="forumrebuild">'."\n";
	$out.= '<input type="hidden" name="forumid" value="'.$forumid.'" />'."\n";
	$out.= '<input type="hidden" name="topicid" value="'.$topicid.'" />'."\n";
	$out.= '<input type="hidden" name="forumslug" value="'.esc_attr($forumslug).'" />'."\n";
	$out.= '<input type="hidden" name="topicslug" value="'.esc_attr($topicslug).'" />'."\n";
	$out.= '<input type="submit" class="spSubmit" name="rebuildforum" value="'.sp_text('Verify').'" />';
	$out.= '</form>'."\n";
	return $out;
}

function sp_rebuild_topic_form($forumid, $topicid, $forumslug, $topicslug) {
	$out = '<form action="'.sp_build_url($forumslug, $topicslug, 1, 0).'" method="post" name="topicrebuild">'."\n";
	$out.= '<input type="hidden" name="forumid" value="'.$forumid.'" />'."\n";
	$out.= '<input type="hidden" name="topicid" value="'.$topicid.'" />'."\n";
	$out.= '<input type="hidden" name="forumslug" value="'.esc_attr($forumslug).'" />'."\n";
	$out.= '<input type="hidden" name="topicslug" value="'.esc_attr($topicslug).'" />'."\n";
	$out.= '<input type="submit" class="spSubmit" name="rebuildtopic" value="'.sp_text('Verify').'" />';
	$out.= '</form>'."\n";
	return $out;
}
?>