<?php
/*
Simple:Press
Forum Topic/Post Saves
$LastChangedDate: 2012-04-05 18:46:26 -0700 (Thu, 05 Apr 2012) $
$Rev: 8269 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# set up required globals
global $spThisUser, $sfglobals;

sp_forum_api_support();
sp_load_editor(0,1);

include_once(SF_PLUGIN_DIR.'/forum/library/sp-post-support.php');

# Initialize the array -------------------------------------------------------------
$newpost = array();
$newpost['error'] = '';
$newpost['forumid'] = 0;
$newpost['forumslug'] = '';

# Validation checks on forum data ---------------------------------------------------
# if the forum is not set then this may be a back door approach
if ((!isset($_POST['forumid'])) || (!isset($_POST['forumslug']))) {
	sp_etext('Forum not set - Unable to create post');
	die();
} else {
	$newpost['forumid'] = sp_esc_int($_POST['forumid']);
	$newpost['forumslug'] = sp_esc_str($_POST['forumslug']);
}

# If forum or system locked then refuse post
if ($spThisUser->admin == false) {
	if ($sfglobals['lockdown'] ? $slock = true : $slock = false);
	if ($slock == false) {
		if (spdb_table(SFFORUMS, 'forum_id='.$newpost['forumid'], 'forum_status') ? $flock = true : $flock = false);
	}
	if ($slock || $flock) {
		sp_etext('This forum is currently locked - access is read only');
		die();
	}
}

# set up the main vars -------------------------------------------------------------
$newpost['topicid'] = 0;
$newpost['topicslug'] = '';
$newpost['postid'] = 0;
$newpost['submsg'] = '';
$newpost['email_prefix'] = '';
$action = '';
if (isset($_POST['newtopic'])) $action = 'topic';
if (isset($_POST['newpost']))  $action = 'post';
$newpost['action'] = $action;

# if this is an existing topic check id and slug is set
if ($action == 'post') {
	if ((!isset($_POST['topicid'])) || (!isset($_POST['topicslug']))) {
		sp_etext('Topic not set - Unable to create post');
		die();
	} else {
		$newpost['topicid'] = sp_esc_int($_POST['topicid']);
		$newpost['topicslug'] = sp_esc_str($_POST['topicslug']);
		$newpost['topicname'] = sp_esc_str($_POST['topicname']);
		$newpost['email_prefix'] = 'Re: ';
	}
}

# check that current user is actually allowed to do this ---------------------------
if (($action == 'topic' && !sp_get_auth('start_topics', $newpost['forumid'])) || ($action == 'post' && !sp_get_auth('reply_topics', $newpost['forumid']))) {
	if (!is_user_logged_in()) {
		sp_etext('Access denied - are you logged in?');
	} else {
		sp_etext('Access denied - you do not have permission');
	}
	die();
}

# set up initial url to return to if save fails ------------------------------------
if ($action == 'topic') {
    $returnURL = sp_build_url($newpost['forumslug'], '', 0, 0);
} else {
    $postid = spdb_table(SFTOPICS, 'topic_id = '.$newpost['topicid'],'post_id');
    $returnURL = sp_build_url($newpost['forumslug'], $newpost['topicslug'], 0, $postid);
}

# setup and prepare post data ------------------------------------------------------
if ($action == 'topic') {
	# topic specific items
	if (empty($_POST['newtopicname'])) {
		sp_notify(1, sp_text('No topic name has been entered and post cannot be saved'));
		wp_redirect($returnURL);
		die();
	} else {
		$newpost['topicname'] = sp_filter_title_save(trim($_POST['newtopicname']));
	}
	$newpost['topicslug'] = sp_create_slug($newpost['topicname'], 'topic');
	$newpost['topicpin'] = 0;
	$newpost['statusflag'] = '0';
	if (isset($_POST['topiclock'])) $newpost['topiclock'] = 1;
	if (isset($_POST['topicpin'])) $newpost['topicpin'] = 1;
	if (isset($_POST['statusflag'])) $newpost['statusflag'] = sp_esc_int($_POST['statusflag']);
}

# post specific (needed by new topic and new post)
$newpost['postpin'] = 0;
$newpost['topiclock'] = 0;
$newpost['statvalue'] = '';
$newpost['posttimestamp'] = current_time('mysql');
if (isset($_POST['postpin'])) $newpost['postpin'] = 1;
if (isset($_POST['topiclock'])) $newpost['topiclock'] = 1;
if (isset($_POST['statvalue'])) $newpost['statvalue'] = sp_esc_int($_POST['statvalue']);
if (!empty($_POST['editTimestamp'])) {
	$yy = sp_esc_int($_POST['tsYear']);
	$mm = sp_esc_int($_POST['tsMonth']);
	$dd = sp_esc_int($_POST['tsDay']);
	$hh = sp_esc_int($_POST['tsHour']);
	$mn = sp_esc_int($_POST['tsMinute']);
	$ss = sp_esc_int($_POST['tsSecond']);
	$dd = ($dd > 31 ) ? 31 : $dd;
	$hh = ($hh > 23 ) ? $hh -24 : $hh;
	$mn = ($mn > 59 ) ? $mn -60 : $mn;
	$ss = ($ss > 59 ) ? $ss -60 : $ss;
	$posttimestamp = sprintf( '%04d-%02d-%02d %02d:%02d:%02d', $yy, $mm, $dd, $hh, $mn, $ss );
	$newpost['posttimestamp'] = ( $posttimestamp );
}

$newpost['poststatus'] = 0;
if (empty($_POST['postitem'])) {
	sp_notify(1, sp_text('No topic post has been entered and post cannot be saved'));
	wp_redirect($returnURL);
	die();
}

$newpost['postcontent'] = $_POST['postitem'];
$newpost['postcontent'] = sp_filter_content_save($newpost['postcontent'], 'new');

# Check if links allowed or if maxmium links have been exceeded
$sffilters = sp_get_option('sffilters');
if (!$spThisUser->admin) {
	if ($sffilters['sfallowlinks']) {
		if ($sffilters['sfmaxlinks'] > 0 && substr_count($newpost['postcontent'], 'http') > $sffilters['sfmaxlinks']) {
			sp_return_to_post($returnURL, sp_text('Maximum number of allowed links exceeded').': '.$sffilters['sfmaxlinks'].' '.sp_text('allowed'));
			die();
		}
	} else {
		if (substr_count($newpost['postcontent'], '</a>') > 0) {
			sp_return_to_post($returnURL, sp_text('You are not allowed to put links in post content'));
			die();
		}
	}
}

$newpost['guestname'] = '';
$newpost['guestemail'] = '';
if ($spThisUser->guest) {
	$sfguests = sp_get_option('sfguests');
	$newpost['guestname'] = sp_filter_name_save($_POST['guestname']);
	$newpost['guestemail'] = sp_filter_email_save($_POST['guestemail']);
	if (empty($newpost['guestname']) || ((empty($newpost['guestemail']) || !is_email($newpost['guestemail'])) && $sfguests['reqemail'])) {
		sp_return_to_post($returnURL, sp_text('Guest name and valid email address required'));
		die();
	}

	# check that the guest name is not the same as a current user
	$checkdupe = spdb_table(SFMEMBERS, "display_name='".$newpost['guestname']."'", 'display_name');
	if (!empty($checkdupe)) {
		sp_return_to_post($returnURL, sp_text('This user name already belongs to a forum member'));
		die();
	}

	# force maximum lengths
	$newpost['guestname'] = substr($newpost['guestname'], 0, 20);
	$newpost['guestemail'] = substr($newpost['guestemail'], 0, 50);
	$newpost['postername'] = sp_filter_name_save($newpost['guestname']);
	$newpost['posteremail'] = sp_filter_email_save($newpost['guestemail']);
	$newpost['userid']='';
} else {
	$newpost['postername'] = sp_filter_name_save($spThisUser->display_name);
	$newpost['posteremail'] = sp_filter_email_save($spThisUser->user_email);
	$newpost['userid'] = $spThisUser->ID;
}

# grab poster IP address and store in db
$newpost['ip'] = sp_get_ip();

# Check for duplicate post of option is set
if (($spThisUser->member && $sffilters['sfdupemember'] == true) || ($spThisUser->guest && $sffilters['sfdupeguest'] == true)) {
	# But not admin or moderator
	if (!$spThisUser->admin && !$spThisUser->moderator) {
		$dupecheck = spdb_table(SFPOSTS, 'forum_id = '.$newpost['forumid'].' AND topic_id='.$newpost['topicid']." AND post_content='".$newpost['postcontent']."' AND poster_ip='".$newpost['ip']."'", 'row', '', '', ARRAY_A);
		if ($dupecheck) {
			sp_return_to_post($returnURL, sp_text('Duplicate post refused'));
			die();
		}
	}
}

# Establish moderation status
$bypassAll  = sp_get_auth('bypass_moderation', $newpost['forumid']);
$bypassOnce = sp_get_auth('bypass_moderation_once', $newpost['forumid']);
if ($bypassAll == true && $bypassOnce == true) {
	$newpost['poststatus'] = 0;
} elseif($bypassAll == false && $bypassOnce == false) {
	$newpost['poststatus'] = 1;
} elseif($bypassAll == true && $bypassOnce == false) {
	$newpost['poststatus'] = 1;
	if ($spThisUser->member) {
		$prior = spdb_table(SFPOSTS, 'user_id='.$newpost['userid'].' AND post_status=0', 'row', '', '1');
		if ($prior) $newpost['poststatus'] = 0;
	} elseif($spThisUser->guest) {
		$prior = spdb_table(SFPOSTS, "guest_name='".$newpost['guestname']."' AND guest_email='".sp_filter_email_display($newpost['guestemail'])."' AND post_status=0", 'row', '', '1');
		if ($prior) $newpost['poststatus'] = 0;
	}
} else {
	$newpost['poststatus'] = 1;
}

# Branch to correct routine --------------------------------------------------------
do_action('sph_pre_post_create', $newpost);
$newpost = apply_filters('sph_new_forum_post', $newpost);

# make sure plugin didnt cancel sending
if (empty($newpost['error'])) {
	if ($action == 'topic') $newpost = sp_create_topic($newpost, $action);
	if ($action == 'post') $newpost = sp_create_post($newpost, $action);
	do_action('sph_post_create', $newpost);

	# reset the url now we should have kosher values and re-direct
	$returnURL = sp_build_url($newpost['forumslug'], $newpost['topicslug'], 0, $newpost['postid']);
	wp_redirect($returnURL);
} else {
	sp_return_to_post($returnURL, $newpost['error']);
}
die();

# ==================================================================================
# CREATION FUNCTIONS
# ==================================================================================

# Create new Topic and First Post --------------------------------------------------
function sp_create_topic($newpost, $action) {
	global $spThisUser, $sfvars;

	# security checks
	check_admin_referer('forum-userform_addtopic', 'forum-userform_addtopic');
	$spamcheck = sp_check_spammath($newpost['forumid']);
	if ($spamcheck[0] == true) {
		sp_notify(1, $spamcheck[1]);
		return;
	}

	# save the new topic record to db
	$newpost = sp_write_topic($newpost);

	if (!$newpost['db']) {
		sp_notify(1, sp_text('Unable to save new topic record'));
		return;
	} 
    
	# check the topic slug and if empty use the topic id
	if (empty($newpost['topicslug'])) {
		$newpost['topicslug'] = 'topic-'.$newpost['topicid'];
		spdb_query('UPDATE '.SFTOPICS." SET topic_slug='".$newpost['topicslug']."' WHERE topic_id=".$newpost['topicid']);
	}

	# Now save the new post record to db
	$newpost = sp_write_post($newpost);
	if (!$newpost['db']) {
		sp_notify(1, sp_text('Unable to save new post message'));
		return;
	} 
    
	spdb_flush();

	# Post-Save New Post Processing
	$newpost = sp_post_save_processing($newpost, $action);

	if ($newpost['poststatus']) $newpost['submsg'] .= ' - '.sp_text('placed in moderation').' ';

	sp_notify(0, sp_text('New topic saved').$newpost['submsg'].' '.$newpost['emailmsg']);
	return $newpost;
}

# Create new Post in existing Topic ------------------------------------------------
function sp_create_post($newpost, $action) {
	global $spThisUser;

	check_admin_referer('forum-userform_addpost', 'forum-userform_addpost');
	$spamcheck = sp_check_spammath($newpost['forumid']);
	if ($spamcheck[0] == true) {
		sp_notify(1, $spamcheck[1]);
		return;
	}
	# Write the post
	$newpost = sp_write_post($newpost);
	if (!$newpost['db']) {
		sp_notify(1, sp_text('Unable to save new post message'));
		return;
	}

	spdb_flush();

	# Post-Save New Post Processing
	$newpost = sp_post_save_processing($newpost, $action);

	if ($newpost['poststatus']) $newpost['submsg'] .= ' - '.sp_text('placed in moderation').' ';

	sp_notify(0, sp_text('New post saved').$newpost['submsg'].' '.$newpost['emailmsg']);
	return $newpost;
}

# ==================================================================================
# DATABASE WRITE FUNCTIONS
# ==================================================================================

# Save new Topic to database -------------------------------------------------------
function sp_write_topic($newpost) {
    global $sfvars;
    
    $newpost = apply_filters('sph_new_topic_pre_data_saved', $newpost);
	$spdb = new spdbComplex;
		$spdb->table	= SFTOPICS;
		$spdb->fields	= array('topic_name', 'topic_slug', 'topic_date', 'forum_id', 'topic_status', 'topic_pinned', 'user_id');
		$spdb->data		= array($newpost['topicname'], $newpost['topicslug'], $newpost['posttimestamp'], $newpost['forumid'], $newpost['topiclock'], $newpost['topicpin'], $newpost['userid']);
	$spdb = apply_filters('sph_new_topic_data', $spdb);
	$newpost['db'] = $spdb->insert();
	if ($newpost['db'] == true) {
		$newpost['topicid'] = $sfvars['insertid'];

		$newpost = apply_filters('sph_new_topic_data_saved', $newpost);
	}

	return $newpost;
}

# Save new Post to database --------------------------------------------------------
function sp_write_post($newpost) {
	global $spThisUser, $sfvars;

	# Double check forum id is correct - it has been known for a topic to have just been moved!
	$newpost['forumid'] = spdb_table(SFTOPICS, 'topic_id='.$newpost['topicid'], 'forum_id');

	# Get post count in topic to enable index setting
	$index = spdb_count(SFPOSTS, 'topic_id = '.$newpost['topicid']);
	$index++;
	$newpost['postindex'] = $index;

	# if topic lock set in post reply update topic
	if ($newpost['topiclock']) spdb_query('UPDATE '.SFTOPICS.' SET topic_status=1 WHERE topic_id='.$newpost['topicid']);

	$newpost = apply_filters('sph_new_post_pre_data_saved', $newpost);
	$spdb = new spdbComplex;
		$spdb->table	= SFPOSTS;
		$spdb->fields	= array('post_content', 'post_date', 'topic_id', 'forum_id', 'user_id', 'guest_name', 'guest_email', 'post_pinned', 'post_index', 'post_status', 'poster_ip');
		$spdb->data		= array($newpost['postcontent'], $newpost['posttimestamp'], $newpost['topicid'], $newpost['forumid'], $newpost['userid'], $newpost['guestname'], $newpost['guestemail'], $newpost['postpin'], $newpost['postindex'], $newpost['poststatus'], $newpost['ip']);
	$spdb = apply_filters('sph_new_post_data', $spdb);
	$newpost['db'] = $spdb->insert();

	if ($newpost['db'] == true) {
		$newpost['postid'] = $sfvars['insertid'];

		$newpost = apply_filters('sph_new_post_data_saved', $newpost);

		if ($spThisUser->guest) {
    		$sfguests = sp_get_option('sfguests');
    		if ($sfguests['storecookie']) sp_write_guest_cookie($newpost['guestname'], $newpost['guestemail']);
		} else {
			$postcount = sp_get_member_item($newpost['userid'], 'posts');
			$postcount++;
			sp_update_member_item($newpost['userid'], 'posts', $postcount);

			# see if postcount qualifies member for new user group membership
			# get rankings information
			if (!$spThisUser->admin) { # ignore for admins as they dont belong to user groups
				global $sfglobals;
				if (!empty($sfglobals['forum_rank'])) {
					$index = 0;
					foreach ($sfglobals['forum_rank'] as $x => $info) {
						$rankdata['title'][$index] = $x;
						$rankdata['posts'][$index] = $info['posts'];
						$rankdata['usergroup'][$index] = $info['usergroup'];
						$index++;
					}
					# sort rankings
					array_multisort($rankdata['posts'], SORT_ASC, $rankdata['title'], $rankdata['usergroup']);

					# check for new ranking
					for ($x=0; $x<count($rankdata['posts']); $x++) {
						if ($postcount <= $rankdata['posts'][$x] && !empty($rankdata['usergroup'][$x])) {
							# if a user group is tied to forum rank add member to the user group
							if ($rankdata['usergroup'][$x] != 'none') {
							    sp_add_membership($rankdata['usergroup'][$x], $newpost['userid']);
                            }
							break;  # only update highest rank
						}
					}
				}
			}
		}
	}

	return $newpost;
}

# ==================================================================================
# POST-SAVE NEW POST ROUTINES
# ==================================================================================

# Post-Save New Post processing ----------------------------------------------------
function sp_post_save_processing($newpost, $action) {
	global $spThisUser;

	# construct new url
	$newpost['url'] = sp_build_url($newpost['forumslug'], $newpost['topicslug'], 0, $newpost['postid']);
	$newpost['submsg'] = '';

	# allow plugins to add to post message
	$newpost['submsg'] = apply_filters('sph_post_message', $newpost['submsg'], $newpost);

	# add to or remove from admins new post queue
	if ($spThisUser->admin || $spThisUser->moderator) {
		# remove topic from waiting...
		sp_remove_from_waiting(false, $newpost['topicid']);
	} else {
		# add topic to waiting
		sp_add_to_waiting($newpost['topicid'], $newpost['forumid'], $newpost['postid'], $newpost['userid']);
	}

	# if post in moderatiuon then add entry to notices
	if($newpost['poststatus'] != 0) {
		$nData = array();
		$nData['user_id']		= $newpost['userid'];
		$nData['guest_email']	= $newpost['guestemail'];
		$nData['post_id']		= $newpost['postid'];
		$nData['link']			= $newpost['url'];
		$nData['link_text']		= $newpost['topicname'];
		$nData['message']		= sp_text('Your post is awaiting moderation in the topic');
		$nData['expires']		= time() + (30 * 24 * 60 * 60); # 30 days; 24 hours; 60 mins; 60secs
		sp_add_notice($nData);
	}

	# send out email notifications
	$newpost['emailmsg'] = '';
	$newpost['emailmsg'] = sp_email_notifications($newpost);

	# Update forum, topic and post index data
	sp_build_post_index($newpost['topicid']);
	sp_build_forum_index($newpost['forumid']);

	return $newpost;
}

# Return to editor if problem
function sp_return_to_post($returnURL, $message) {
	# place details in transient cache
	$failure = array();
	$failure['message'] = sp_text('Unable to save').'<br />'.$message;
	if (isset($_POST['newtopicname']) ? $failure['newtopicname'] = $_POST['newtopicname'] : $failure['newtopicname'] = '');
	if (isset($_POST['guestname']) ? $failure['guestname'] = $_POST['guestname'] : $failure['guestname'] = '');
	if (isset($_POST['guestemail']) ? $failure['guestemail'] = $_POST['guestemail'] : $failure['guestemail'] = '');
	$failure['postitem'] = $_POST['postitem'];

	sp_add_transient(1, $failure);
	wp_redirect($returnURL);
}

?>